﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using TransmissionIFR.Models;
using System.Xml.Linq;
using System.Web.Script.Serialization;
using Newtonsoft.Json;



namespace TransmissionIFR.Controllers
{
    public class ProjectsController : Controller
    {
        private IFRScorecardContext db = new IFRScorecardContext();

        public ActionResult Index()
        {
            return View();
        }

        public ActionResult UpdateURLAction()
        {
            var json = this.HttpContext.Request.Form["ig_transactions"];

            ReturnedProject[] results = JsonConvert.DeserializeObject<ReturnedProject[]>(json);

            foreach (ReturnedProject pr in results)
            {

                switch (pr.type)
                {
                    case "newrow":
                        Project tp = new Project
                        {
                            IFRSubmittalDate = pr.row.IFRSubmittalDate,
                            Station = pr.row.Station,
                            WorkOrder = pr.row.WorkOrder,
                            ReqType = pr.row.ReqType,
                            OperatingCompany = pr.row.OperatingCompany,
                            PVID = pr.row.PVID,
                            AEPIFRReturnDate = new DateTime(2012, 12, 12),
                            IFCSubmittalDate = new DateTime(2012, 12, 12)
                        };


                        var returnerproject = db.Projects.Add(tp);
                        db.SaveChanges();
                        break;
                    case "deleterow":
                        var deleteEntity = db.Projects.Where(pr2 => pr2.ProjectID == pr.rowID).FirstOrDefault();

                        db.Projects.Remove(deleteEntity);
                        db.SaveChanges();
                        break;
                    case "row":

                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().ProjectStatus = pr.row.ProjectStatus;
                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().IFCSubmittalDate = pr.row.IFCSubmittalDate;
                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().Station = pr.row.Station;
                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().WorkOrder = pr.row.WorkOrder;
                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().ReqType = pr.row.ReqType;
                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().OperatingCompany = pr.row.OperatingCompany;
                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().PVID = pr.row.PVID;
                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().AEPIFRReturnDate = new DateTime(2012, 12, 12);
                        (from pr3 in db.Projects where pr3.ProjectID == pr.rowID select pr3).Single().IFCSubmittalDate = new DateTime(2012, 12, 12);

                        db.SaveChanges();
                        break;
                    default:
                        break;
                }
            }

            JsonResult result = new JsonResult();
            Dictionary<string, object> response = new Dictionary<string, object>();
            response.Add("Success", true);

            result.Data = response;
            return result;
        }

        public JsonResult GetProjects()
        {
            var data = db.Projects.Select(x => new
            {
                x.ProjectID,
                x.IFRSubmittalDate,
                x.ProjectStatus,
                x.PVID,
                x.WorkOrder,
                x.ReqType,
                x.OperatingCompany,
                x.Station
            });

            if (data != null)
            {
                return new JsonResult() { Data = data, JsonRequestBehavior = JsonRequestBehavior.AllowGet };
            }
            return new JsonResult() { Data = new object[] { }, JsonRequestBehavior = JsonRequestBehavior.AllowGet };
        }


        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}
