using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace TransmissionIFR.Models.Mapping
{
    public class ProjectMap : EntityTypeConfiguration<Project>
    {
        public ProjectMap()
        {
            // Primary Key
            this.HasKey(t => t.ProjectID);

            // Properties
            this.Property(t => t.Station)
                .HasMaxLength(50);

            this.Property(t => t.OperatingCompany)
                .HasMaxLength(50);

            this.Property(t => t.WorkOrder)
                .HasMaxLength(20);

            this.Property(t => t.AEPLead)
                .HasMaxLength(50);

            this.Property(t => t.OECCompany)
                .HasMaxLength(50);

            this.Property(t => t.OECTeamLocation)
                .HasMaxLength(100);

            this.Property(t => t.OECEngineer)
                .HasMaxLength(50);

            this.Property(t => t.OECPeerReviewer)
                .HasMaxLength(50);

            this.Property(t => t.QACompleted)
                .HasMaxLength(10);

            this.Property(t => t.ProjectStatus)
                .HasMaxLength(50);

            this.Property(t => t.ReqType)
                .HasMaxLength(50);

            // Table & Column Mappings
            this.ToTable("Projects");
            this.Property(t => t.ProjectID).HasColumnName("ProjectID");
            this.Property(t => t.Station).HasColumnName("Station");
            this.Property(t => t.OperatingCompany).HasColumnName("OperatingCompany");
            this.Property(t => t.ProjectDescription).HasColumnName("ProjectDescription");
            this.Property(t => t.PVID).HasColumnName("PVID");
            this.Property(t => t.WorkOrder).HasColumnName("WorkOrder");
            this.Property(t => t.AEPLead).HasColumnName("AEPLead");
            this.Property(t => t.OECCompany).HasColumnName("OECCompany");
            this.Property(t => t.OECTeamLocation).HasColumnName("OECTeamLocation");
            this.Property(t => t.OECEngineer).HasColumnName("OECEngineer");
            this.Property(t => t.OECEngAEPExperience).HasColumnName("OECEngAEPExperience");
            this.Property(t => t.OECEngOverallExperience).HasColumnName("OECEngOverallExperience");
            this.Property(t => t.OECPeerReviewer).HasColumnName("OECPeerReviewer");
            this.Property(t => t.OECPeerAEPExperience).HasColumnName("OECPeerAEPExperience");
            this.Property(t => t.OECPeerOverallExperience).HasColumnName("OECPeerOverallExperience");
            this.Property(t => t.QACompleted).HasColumnName("QACompleted");
            this.Property(t => t.IFRSubmittalDate).HasColumnName("IFRSubmittalDate");
            this.Property(t => t.AEPIFRReturnDate).HasColumnName("AEPIFRReturnDate");
            this.Property(t => t.IFCSubmittalDate).HasColumnName("IFCSubmittalDate");
            this.Property(t => t.ProjectwiseIFRFolderURL).HasColumnName("ProjectwiseIFRFolderURL");
            this.Property(t => t.ProjectStatus).HasColumnName("ProjectStatus");
            this.Property(t => t.ReqType).HasColumnName("ReqType");
        }
    }
}
